<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */
namespace App\Http\Validators;

use App\Http\Base\Validation;

class ActivitylogValidator extends Validation
{
    /**
    * this function will call before insert, you can custom as your business requirement
    * @param array $input
    * @return $this
    */
    public function beforeInsert($input){
		if(empty($input["userId"])){
			array_push($this->error, ["userId" => "cannot be null"]);
		}
		else{
			$lengthuserid = strlen($input["userId"]);
			if($lengthuserid>19){
			array_push($this->error, ["userid" => "value too long"]);
			}
		}
		$users= (new \App\Http\Models\UsersModel())
			->getQuery()->where("id","=",$input["userId"])->first();
		if(empty($users)){
			array_push($this->error, ["userId" => "invalid relation"]);
		}
		if(empty($input["activity"])){
			array_push($this->error, ["activity" => "cannot be null"]);
		}
		else{
			$lengthactivity = strlen($input["activity"]);
			if($lengthactivity>3){
			array_push($this->error, ["activity" => "value too long"]);
			}
		}
		if(empty($input["date"])){
			array_push($this->error, ["date" => "cannot be null"]);
		}
		else{
			$lengthdate = strlen($input["date"]);
			if($lengthdate>0){
			array_push($this->error, ["date" => "value too long"]);
			}
		}
		if(empty($input["module"])){
			array_push($this->error, ["module" => "cannot be null"]);
		}
		else{
			$lengthmodule = strlen($input["module"]);
			if($lengthmodule>3){
			array_push($this->error, ["module" => "value too long"]);
			}
		}
		if(empty($input["refId"])){
			array_push($this->error, ["refId" => "cannot be null"]);
		}
		else{
			$lengthrefid = strlen($input["refId"]);
			if($lengthrefid>19){
			array_push($this->error, ["refid" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before update into database, you can custom as your business requirement
    * @param array $input
    * @param $id
    * @return $this
    */
    public function beforeUpdate($input,$id){
		if(empty($input["userId"])){
			array_push($this->error, ["userId" => "cannot be null"]);
		}
		else{
			$lengthuserid = strlen($input["userId"]);
			if($lengthuserid>19){
			array_push($this->error, ["userid" => "value too long"]);
			}
		}
		if(!empty($input["userId"])){
		$users= (new \App\Http\Models\UsersModel())
			->getQuery()->where("id","=",$input["userId"])->first();
		if(empty($users)){
			array_push($this->error, ["userId" => "invalid relation"]);
		}
		}
		if(empty($input["activity"])){
			array_push($this->error, ["activity" => "cannot be null"]);
		}
		else{
			$lengthactivity = strlen($input["activity"]);
			if($lengthactivity>3){
			array_push($this->error, ["activity" => "value too long"]);
			}
		}
		if(empty($input["date"])){
			array_push($this->error, ["date" => "cannot be null"]);
		}
		else{
			$lengthdate = strlen($input["date"]);
			if($lengthdate>0){
			array_push($this->error, ["date" => "value too long"]);
			}
		}
		if(empty($input["module"])){
			array_push($this->error, ["module" => "cannot be null"]);
		}
		else{
			$lengthmodule = strlen($input["module"]);
			if($lengthmodule>3){
			array_push($this->error, ["module" => "value too long"]);
			}
		}
		if(empty($input["refId"])){
			array_push($this->error, ["refId" => "cannot be null"]);
		}
		else{
			$lengthrefid = strlen($input["refId"]);
			if($lengthrefid>19){
			array_push($this->error, ["refid" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before delete from database, you can custom as your business requirement
    * @param $id
    * @return $this
    */
    public function beforeDelete($id){
	return $this;

    }


}